package com.demo.service;

import org.springframework.ai.document.Document;
import org.springframework.ai.vectorstore.SearchRequest;
import org.springframework.ai.vectorstore.VectorStore;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class VectorService {

    @Autowired
    VectorStore vectorStore;

    public List<Document> simpleVector(String query) {
        List<Document> documents = List.of(
                new Document(
                        "Spring Framework simplifies development across multiple domains.".repeat(3),
                        Map.of("author", "John Doe", "category", "Tech")
                ),
                new Document("Cloud Computing: The Next Frontier in Software Architecture"),
                new Document("Exploring the Evolution of Microservices Architecture"),
                new Document(
                        "Innovative solutions emerge when we challenge the status quo.",
                        Map.of("author", "Jane Smith", "category", "Innovation")
                )
        );

        vectorStore.add(documents);

        return vectorStore.similaritySearch(
                SearchRequest.defaults()
                        .withQuery(query)
                        .withTopK(2)
        );
    }
}
